
#include "display.h"

/* monster file for formatting the main display */
static int Display_Row, Display_Col;
int DiTopIndex;
int DiCurrentRow = 2;
int DiRowCount;
int DiState = DI_STATE_INIT;

void display_draw(void)
{
     /* display review
	line 0 - menu line
	line 1 - caption/header line
	...    - data lines
	line n - status line */

     int k;
     int fdate = 1;
     int fnumber = 2;
     int fpayee = 5;
     int famount = 4;
     int fbalance = 10;

     /* draw caption line */
     SLsmg_gotorc(1, 0);
     
     SLsmg_printf("%-8s ", "Date");
     SLsmg_printf("%-6s ", "Num");
     SLsmg_printf("%-40s ", "Payee");
     SLsmg_printf("%-9s ", "Amount");
     SLsmg_printf("%-9s ", "Balance");
     SLsmg_erase_eol ();


     /* fill the remainig space with records */
     for (k=2; k<SLtt_Screen_Rows - 1; k++){
	  /* goto first col of row */
	  SLsmg_gotorc(k, 0);
	  /* get data */
	  if (k == DiCurrentRow){
	       SLsmg_reverse_video();
	  }
	  else {
	       SLsmg_normal_video();
	  }
	  /* we had to be careful here since pointers to data
	     were getting overwritten when we try to store them all
	     up then print them.  but if we just print them off
	     and go to the next one all is much better. jmr */
	  SLsmg_printf("%8s ", intrin_acc_field(&k, &fdate));
	  SLsmg_printf("%6s ", intrin_acc_field(&k, &fnumber));
	  SLsmg_printf("%-40s ", intrin_acc_field(&k, &fpayee));
	  SLsmg_printf("%9s ", intrin_acc_field(&k, &famount));
	  SLsmg_printf("%9s ", intrin_acc_field(&k, &fbalance));
	  SLsmg_erase_eol ();

     }

}

void display_keyup(void){
     if (DiCurrentRow > 2){
	  
	  DiCurrentRow--;
     }
     else{
	  DiCurrentRow = 2;
     }
     display_hilite_row();  
}

void display_keydown(void){
     if (DiCurrentRow < SLtt_Screen_Rows - 1){
	  DiCurrentRow++;
     }
     else{
	  /* inc top index by screenrows and reset current */
	  DiCurrentRow = SLtt_Screen_Rows - 1;
     }
     display_hilite_row();
}

void display_hilite_row(void){
     SLsmg_gotorc(DiCurrentRow, 0);
     /*SLtt_set_color(7, NULL, "green", "black");*/
     SLsmg_reverse_video();
     SLsmg_set_color_in_region(7, DiCurrentRow, 1, 0, SLtt_Screen_Cols);
     SLsmg_normal_video();
}

void display_store_cursor(void)
{
     Display_Row = SLsmg_get_row();
     Display_Col = SLsmg_get_column();
}


void display_restore_cursor(void)
{
     SLsmg_gotorc(Display_Row, Display_Col);
}
