
#include "main.h"

int main() 
{
     /* initialize the terminal level */
     if (-1 == terminal_init(1, 1))
     {
	  fprintf (stderr, "Unable to initialize terminal.");
	  return 1;
     }
     /* intitalize the slang interp with anvil extensions */
     if (EXIT_FAILURE == interp_init()){
	  return -1;
     }
     /* a temp line for test */
     intrin_acc_read("../../books/test_acct/CHKTRANS.QIF");

     main_loop();   /* should not return */

     return 1;
}

void update_display (void)
{
     /* All well behaved applications should block signals that may affect
      * the display while performing screen update.
    */

     SLsig_block_signals();
     SLsmg_normal_video();
     SLsmg_gotorc(0, 0);

     /* draw stuff to terminal */
     switch (DiState){
     case DI_STATE_INIT:
	  display_draw();
	  status_draw();
	  menu_draw();
	  break;
     case DI_STATE_MENU:
	  menu_draw();
	  break;
     case DI_STATE_MAIN:
	  display_draw();
	  break;
     case DI_STATE_STATUS:
	  status_draw();
	  break;
     default:
	  break;
     }

     SLsmg_refresh();
     SLsig_unblock_signals();
}
     


void main_loop (void)
{
     
     while (1)
     {
	  update_display();
	  switch (SLkp_getkey())
	  {
	  case SL_KEY_ERR:
	  case 'q':
	  case 'Q':
	       terminal_exit(0);
	       break;
	  case SL_KEY_F0+10:
	       if (MenuGrpVisible == FALSE) {
		    MenuGrpVisible = TRUE;
		    DiState = DI_STATE_MENU;
	       }
	       else {
		    MenuGrpVisible = FALSE;
		    DiState = DI_STATE_MAIN;
	       }
	       break;
	  case SL_KEY_UP:
	       if (MenuGrpVisible == TRUE){
		    menugrp_keyup();
		    DiState = DI_STATE_MENU;
	       }
	       else {
		    display_keyup();
		    DiState = DI_STATE_MAIN;
	       }
	       break;
	  case SL_KEY_DOWN:
	       if (MenuGrpVisible == TRUE){
		    menugrp_keydown();
		    DiState = DI_STATE_MENU;
	       }
	       else {
		    display_keydown();
		    DiState = DI_STATE_MAIN;
	       }
	       break;
	  case SL_KEY_RIGHT:
	       MenuItemCurrent = 0;
	       if (MenuGrpVisible == TRUE){
		    if (MenuGrp < NUM_MENU_GROUPS) {
			 MenuGrp++;
		    }
		    else {
			 MenuGrp = 0;
		    }
	       }
	       menu_draw();
	       break;
	  case SL_KEY_LEFT:
	       MenuItemCurrent = 0;
	       if (MenuGrpVisible == TRUE){
		    if (MenuGrp > 0) {
			 MenuGrp--;
		    }
		    else {
			 MenuGrp = NUM_MENU_GROUPS;
		    }
	       }
	       
	       break;
	      
	  case 13:
	       /* enter key */
	       if (MenuGrpVisible == TRUE){
		    menu_do_callback();
		    MenuGrpVisible = FALSE;
		   
	       }
	       else {
		    StatusState = ST_NORMAL;
		    SLtt_beep();
		    
	       }
	       
	       break;
	  default:
	       SLtt_beep ();
	  }
     }
}



int interp_init(void)
{
     if (-1 == SLang_init_all ())
	  return (EXIT_FAILURE);

     if (-1 == SLadd_intrin_fun_table (Acc_Intrinsics, NULL)){
	  return (EXIT_FAILURE);
     }
     return 0;
}


