
#include "menu.h"
#include "callback.h"

const int ACCOUNT = 0;
const int NUM_GRP_ACCOUNT_ITEMS = 6;
const int ACTIVITY = 1;
const int NUM_GRP_ACTIVITY_ITEMS = 3;
const int TRANSACTION = 2;
const int NUM_GRP_TRANSACTION_ITEMS = 6;


/* extern variables */
int MenuGrpVisible = 0;
int MenuGrp = 0;
int MenuItemCurrent = 0;

/* internal variables */
int MenuBar = 0;
int MenuItemSelected = 0;

static int MenuGrpWidth = 0;

int top, left, width, height, border, count;


struct menuitem {
     char label[16];
     void (*func) ();
};
struct menuitem *grp = NULL;

struct menuitem grp_account[NUM_GRP_ACCOUNT_ITEMS] = {
     {"New", NULL},
     {"Open", cb_open},
     {"Close  Ctrl-X", NULL},
     {"Save", NULL},
     {"Save As", NULL},
     {"Exit", NULL}
};

struct menuitem grp_activity[NUM_GRP_ACTIVITY_ITEMS] = {
     {"Import", NULL},
     {"Export", NULL},
     {"Reconcile", NULL},
};

struct menuitem grp_transaction[NUM_GRP_TRANSACTION_ITEMS] = {
     {"New", NULL},
     {"Edit", NULL},
     {"Void", NULL},
     {"Find", NULL},
     {"Memorize", NULL},
     {"Delete", NULL}
};

void menu_draw(void){
     SLsmg_gotorc(0, 0);
     SLsmg_printf("%s", "F10=>  Account  Activity  Transaction  Report  Options  Help");
     SLsmg_normal_video();
     
     if (MenuGrpVisible == TRUE) { 
	  menugrp_show(MenuGrp); 
	  menuitem_hilite();
     }
}


void menugrp_show(int group){
     /* draw a drop down region */
     /* draw the menu grp labels */
     int k;

     /*start of show group always resets current*/
     /* MenuItemCurrent = 0; */

     /* switch statement for each main menu item */
     /* common items*/
     top = 1;
     border = 1;
     /* each item would have its params */
     switch (group){
     case ACCOUNT:
	  left = 6;
	  width = 15;
	  height = NUM_GRP_ACCOUNT_ITEMS+border;
	  count = NUM_GRP_ACCOUNT_ITEMS;
	  grp = &grp_account[0];
	  break;
     case ACTIVITY:
	  left = 16;
	  width = 15;
	  height = NUM_GRP_ACTIVITY_ITEMS+border;
	  
	  count = NUM_GRP_ACTIVITY_ITEMS;
	  grp = &grp_activity[0];
	  break;
     case TRANSACTION:
	  left = 26;
	  width = 15;
	  height = NUM_GRP_TRANSACTION_ITEMS+border;
	  
	  count = NUM_GRP_TRANSACTION_ITEMS;
	  grp = &grp_transaction[0];
	  break;
     default:
	  break;
     }


     SLsmg_draw_box(top, left, height+border, width+border);
     SLsmg_fill_region(top+border, left+border, height-border, width-border, ' ');

     for (k=0; k<count; k++){
	  SLsmg_gotorc(top+border+k, left+border);
	  SLsmg_printf("%s", grp[k].label);
     }
     SLsmg_gotorc(top+border, left+border);

}

void menugrp_keyup(void){
     if (MenuItemCurrent > 0) {
	  MenuItemCurrent--;
     }
     
     menu_draw();
}

void menugrp_keydown(void){
     if (MenuItemCurrent < count-1) {
	  MenuItemCurrent++;
     }

     menu_draw();
}

void menuitem_hilite(void){
     int l_row;

     l_row = top+border+MenuItemCurrent;
     SLsmg_gotorc(l_row, left+border);
     SLsmg_set_color_in_region(SLSMG_COLOR_BLUE, 
			       l_row, left+border, 
			       1, width-left-(2*border));
}

void menu_do_callback(void){
     if (*grp[MenuItemCurrent].func != NULL) {
	  (*grp[MenuItemCurrent].func) ();
     }
}
