// 
// Project: Anvil
// Personal Finance Application for Linux
//
// Joseph M. Robertson, jmr, jmrobert5@mchsi.com
//
// Copyright(c) 2001, Joseph M. Robertson.
// This code protected by the GNU Public License.
// See the LICENSE file or http://www.gnu.org for details.
//

#include <string>

//robodoc code
//****h* Anvil/Category
//
// NAME
//  Category header
// USAGE
//  #include "category.h"
//  Category c = new Category();
// AUTHOR
//  Joseph M. Robertson, jmr, jmrobert5@mchsi.com
// COPYRIGHT
// (c) 2001 by Joseph M. Robertson
// CREATION DATE
//  11/26/99
// HISTORY
//***
//

class Category{
public:
     void Name(string name);
     string Name();

     void Description(string descrip);
     string Description();

     //income, expense
     void Type(string type);
     string Type();

     void SubCategory(string subcat);
     string SubCategory();

     //0 for no, 1 for yes
     void Tax_Related(int taxrelated);
     int Tax_Related();
     
     //a string for the tax form number
     void Tax_Form(string formid);
     string Tax_Form();

private:
     string name, description, type, subcategory, formid;
     int taxrelated;
     
};
