// 
// Project: Anvil
// Personal Finance Application for Linux
//
// Joseph M. Robertson, jmr, jmrobert5@mchsi.com
//
// Copyright(c) 2001, Joseph M. Robertson.
// This code protected by the GNU Public License.
// See the LICENSE file or http://www.gnu.org for details.
//

#include "qif4.h"
#include <assert.h>

//robodoc code
//****c* Anvil/Qif4
//
// NAME
//  Qif4 class
// CHILDREN
//  Anvil/Qif4Basic
// USAGE
//  A basic abstract class, you must derive something from this.
//  #include "qif4.h"
// AUTHOR
//  Joseph M. Robertson, jmr, jmrobert5@mchsi.com
// COPYRIGHT
// (c) 2001 by Joseph M. Robertson
// CREATION DATE
//  11/18/99
// HISTORY
//  6/20/01  Changed to be an abstract base class.
//***
//

Qif4::Qif4(){
}

Qif4::~Qif4(){
}

string Qif4::Trim(string value){
     int i = value.find("\r");
     if (i > 0) {
	  //a dos line
	  value.replace(i, 2, "\0");
     }
     else {
	  //another use /n
	  i = value.find("/n");
	  if (i > 0){
	       value.replace(i, 2, "\0");
	  }
     }
     return value;
}


