// 
// Project: Anvil
// Personal Finance Application for Linux
//
// Joseph M. Robertson, jmr, jmrobert5@mchsi.com
//
// Copyright(c) 2001, Joseph M. Robertson.
// This code protected by the GNU Public License.
// See the LICENSE file or http://www.gnu.org for details.
//

#ifndef QIF4_H
#define QIF4_H

#include <vector>
#include <string>
#include <fstream>

#include "transaction.h"
#include "trbasic.h"
#include "split.h"
#include "msg.h"

//robodoc code
//****h* Anvil/Qif4
//
// NAME
//  Qif4 class
// USAGE
//  A basic abstract class, you must derive something from this.
//  #include "qif4.h"
// AUTHOR
//  Joseph M. Robertson, jmr, jmrobert5@mchsi.com
// COPYRIGHT
// (c) 2001 by Joseph M. Robertson
// CREATION DATE
//  11/18/99
// HISTORY
//  6/20/01  Changed to be an abstract base class.
//***
//


class Qif4 {

public:
     Qif4();
     virtual ~Qif4();

     string Trim(string value);
     virtual void Read(string filename, vector<Transaction*> *vTrans) = 0;
     virtual void Write(string filename, vector<Transaction*> *vTrans) = 0;


};

#endif
