// 
// Project: Anvil
// Personal Finance Application for Linux
//
// Joseph M. Robertson, jmr, jmrobert5@mchsi.com
//
// Copyright(c) 2001, Joseph M. Robertson.
// This code protected by the GNU Public License.
// See the LICENSE file or http://www.gnu.org for details.
//

#ifndef QIF4BASIC_H
#define QIF4BASIC_H

#include <vector>
#include <string>
#include <fstream>

#include "transaction.h"
#include "trbasic.h"
#include "split.h"
#include "msg.h"
#include "qif4.h"

//robodoc code
//****c* Anvil/Qif4Basic
//
// NAME
//  Qif4Basic class
// USAGE
//  #include "qif4basic.h"
//  Qif4Basic *q = new Qif4Basic();
// AUTHOR
//  Joseph M. Robertson, jmr, jmrobert5@mchsi.com
// COPYRIGHT
// (c) 2001 by Joseph M. Robertson
// CREATION DATE
//  6/20/01
// HISTORY
// NOTES
//  This class reads all transaction types except investment transactions.
// DERIVED FROM
//  Anvil/Qif4
//***
//

class Qif4Basic : public Qif4 {

public:
     Qif4Basic();
     ~Qif4Basic();

     //must override these methods for each input file type
     void Read(string filename, vector<Transaction*> *vTrans);
     void Write(string filename, vector<Transaction*> *vTrans);


private:
     string line;
     string key;
     string value;
     vector<Split> vSplit;
};

#endif
