/* 
 * Project: Anvil
 * Personal Finance Application for Linux
 *
 * Joseph M. Robertson, jmr, jmrobert5@mchsi.com
 *
 * Copyright(c) 2001, Joseph M. Robertson.
 * This code protected by the GNU Public License.
 * See the LICENSE file or http://www.gnu.org for details.
 */

/*
 * test program for anvil intrinsics 
 * added to slang interp
 */

#include "sl_int.h"

#ifdef __cplusplus
extern "C" {
#endif 

#include <stdio.h>

/* robodoc code */
/****h* Anvil/sl_main
 *
 * NAME
 *  S-Lang test shell
 * USAGE
 *  main <script.sl>
 * AUTHOR
 *  Joseph M. Robertson, jmr, jmrobert5@mchsi.com
 * COPYRIGHT
 * (c) 2001 by Joseph M. Robertson
 * CREATION DATE
 *  3/18/01
 * HISTORY
 ******
 */

int main(int argc, char *argv[]) {

	if (argc > 1){
     
		if (-1 == SLang_init_all ())
			exit (EXIT_FAILURE);

		
		if (-1 == SLadd_intrin_fun_table (Acc_Intrinsics, NULL)){
			exit (EXIT_FAILURE);
		}
		
		if (-1 == SLang_load_file ( argv[1] )) {
			SLang_restart (1);
			SLang_Error = 0;
		}

	}

	else {
		printf("Usage:  main <script.sl>\n");
	}

	return 0;
}


#ifdef __cplusplus
}
#endif 

