// 
// Project: Anvil
// Personal Finance Application for Linux
//
// Joseph M. Robertson, jmr, jmrobert5@mchsi.com
//
// Copyright(c) 2001, Joseph M. Robertson.
// This code protected by the GNU Public License.
// See the LICENSE file or http://www.gnu.org for details.
//

#include "account.h"
#include <iostream>
#include <string>
using namespace std;

//robodoc code
//****c* Anvil/test
//
// NAME
//  Anvil test exe
// USAGE
//  ./test
// AUTHOR
//  Joseph M. Robertson, jmr, jmrobert5@mchsi.com
// COPYRIGHT
// (c) 2001 by Joseph M. Robertson
// CREATION DATE
//  3/18/01
// HISTORY
//***
//

int main() {
     int k=0;

     Account *a = new Account();
     a->Type("Bank");
     a->Name("Checking");
     a->Read("./books/test_acct/CHKTRANS.QIF");
     
     TrBasic *t;
     
     for (k = 0; k < a->Size(); k++){
	  t = (TrBasic*)a->Get(k);
	  string o = t->Print();
	  cout << o << endl;
     }

     cout << "Account Balance: " << a->Balance() << endl;

     cout << "Delete record id 2.\n";
     try {
	  a->Delete(2);
     }
     catch (Msg &msg){
	  msg.Print();
     }

     for (k = 0; k < 4; k++){
	  t = (TrBasic*)a->Get(k);
	  string o = t->Print();
	  cout << o << endl;
     }
     cout << "Account Balance: " << a->Balance() << endl;

     cout << "Write test.\n";
     a->Write("./writetest.qif");

     cout << "Delete record id -1.\nException Test.\n";
     try {
	  a->Delete(-1);
     }
     catch (Msg &msg){
	  msg.Print();
     }

}

