// 
// Project: Anvil
// Personal Finance Application for Linux
//
// Joseph M. Robertson, jmr, jmrobert5@mchsi.com
//
// Copyright(c) 2001, Joseph M. Robertson.
// This code protected by the GNU Public License.
// See the LICENSE file or http://www.gnu.org for details.
//

#ifndef TRBASIC_H
#define TRBASIC_H

#include <stdio.h>
#include <vector>
#include <string>
#include "split.h"
#include "msg.h"
#include "transaction.h"

//robodoc code
//****c* Anvil/TrBasic
//
// NAME
//  Transaction Basic class
// USAGE
//  #include "trbasic.h"
//  TrBasic *t = new TrBasic();
// AUTHOR
//  Joseph M. Robertson, jmr, jmrobert5@mchsi.com
// COPYRIGHT
// (c) 2001 by Joseph M. Robertson
// CREATION DATE
//  6/17/01
// HISTORY
//***
//

class TrBasic : public Transaction {
public:
     TrBasic();
     ~TrBasic();
     
     float Amount();
     void Amount(float value);
     
     //void the transaction
     void Void();
     long Number();
     void Number(long value);
     
     string Address();
     void Address(string value);
     string Category();
     void Category(string value);
     float Balance();
     void Balance(float value);
     void VSplit(vector<Split> vsplit);
     vector<Split> VSplit();

     //formatted string of transaction
     //useful for test or console
     string Print();  
     string Print_Rec();

     //get field data
     string Field(int index);
     
private:
     
     float amount;
     
     long number;
     
     string address;
     string category;
     float balance;
     vector<Split> split;

     //method recalcs trans amount when splits change
     void ReBalance();
     
};

#endif
