/*******************************************************
Copyright (C) 2009 VaDiM

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************/
#ifndef MM_EX_CONSTANTS_H_
#define MM_EX_CONSTANTS_H_

#include "defs.h"
//----------------------------------------------------------------------------

class wxString;

extern const wxSizerFlags g_flags;
extern const wxSizerFlags g_flagsExpand;

namespace mmex
{
extern const int MIN_DATAVERSION;
extern const wxString DATAVERSION;

extern const wxString DEFDATEFORMAT;
extern const wxString DEFDELIMTER;

/*
        Uses for titles, reports, etc.
        Do not use mmex::GetAppName() for such things.
*/
const wxString getProgramName();
const wxString getTitleProgramVersion();
const wxString getProgramVersion();
const wxString getProgramCopyright();
const wxString getProgramDescription();

namespace weblink
{
    const wxString addReferralToURL(const wxString& BaseURL, const wxString& CampSource);
    extern const wxString WebSite;
    extern const wxString Update;
    extern const wxString UsageStats;
    extern const wxString Download;
    extern const wxString News;
    extern const wxString Forum;
    extern const wxString Wiki;
    extern const wxString BugReport;
    extern const wxString Donate;
    extern const wxString Twitter;
    extern const wxString Facebook;
    extern const wxString YahooQuotes;
    extern const wxString DefStockUrl;
} // namespace weblink
} // namespace mmex

extern const wxString VIEW_TRANS_ALL_STR;            
extern const wxString VIEW_TRANS_TODAY_STR;          
extern const wxString VIEW_TRANS_CURRENT_MONTH_STR;  
extern const wxString VIEW_TRANS_LAST_30_DAYS_STR;   
extern const wxString VIEW_TRANS_LAST_90_DAYS_STR;   
extern const wxString VIEW_TRANS_LAST_MONTH_STR;     
extern const wxString VIEW_TRANS_LAST_3MONTHS_STR;   
extern const wxString VIEW_TRANS_LAST_12MONTHS_STR;  
extern const wxString VIEW_TRANS_CURRENT_YEAR_STR;   

extern const wxString VIEW_ACCOUNTS_ALL_STR;       
extern const wxString VIEW_ACCOUNTS_OPEN_STR;      
extern const wxString VIEW_ACCOUNTS_FAVORITES_STR; 

extern const wxString LANGUAGE_PARAMETER;
extern const wxString INIDB_USE_TRANSACTION_SOUND;
extern const wxString INIDB_USE_ORG_DATE_COPYPASTE;

extern const wxString INIDB_BUDGET_FINANCIAL_YEARS;
extern const wxString INIDB_BUDGET_INCLUDE_TRANSFERS;
extern const wxString INIDB_BUDGET_SETUP_WITHOUT_SUMMARY;
extern const wxString INIDB_BUDGET_SUMMARY_WITHOUT_CATEG;
extern const wxString INIDB_IGNORE_FUTURE_TRANSACTIONS;

extern const wxString ATTACHMENTS_FOLDER_DOCUMENTS;
extern const wxString ATTACHMENTS_FOLDER_DATABASE;
extern const wxString ATTACHMENTS_FOLDER_USERPROFILE;
extern const wxString ATTACHMENTS_FOLDER_APPDATA;

#endif // MM_EX_CONSTANTS_H_
//----------------------------------------------------------------------------
